/*  Canon LIPS IV Driver for PDAPI Ver. 1.0.0
 *  Copyright CANON INC. 2004
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */




#ifndef	_COMMON_H_
#define	_COMMON_H_


void	dbgMessage(const char *fmt, ...);

pdFix	int2fix(int i);
int		fix2int(pdFix fix);
float	fix2float(pdFix fix);
int		double2int(double d);

int	Dev_x_fConv(pdFix fx, pdFix fy, pdCTM *ctm);
int	Dev_y_fConv(pdFix fx, pdFix fy, pdCTM *ctm);
pdFix Dev_x_fConvF(pdFix fx, pdFix fy, pdCTM *ctm);
pdFix Dev_y_fConvF(pdFix fx, pdFix fy, pdCTM *ctm);

void				InitializeCTM(pdCTM *ctm);
printerContextData	*CreatePrinterContext(int fd);
bool				DeletePrinterContext(int printerContext);
printerContextData	*GetPrinterContext(int printerContext);
GraphicsStateData	*GetGraphicsState(int printerContext);
void				CleanGraphicsState(GraphicsStateData *gsdata);
void				InitializeGraphicsState(GraphicsStateData *gsdata);
pdBrushData			*DuplicateBrushData(pdBrushData *src);
void				DeleteBrushData(pdBrushData *ptr);
bool				CopyBrush(pdBrush *dst, pdBrush *src);
void				SetSolidBrush(pdBrush *pb, int R, int G, int B);
bool				CopyGraphicsState(GraphicsStateDataList *dst, GraphicsStateDataList *src);

bool				getFormParam(CnpkPageInfo *pageinfo, pdFormParam *formparam);

void sigtermHandler(int sig);

#endif
