/*  Canon LIPS IV Driver for PDAPI Ver. 1.0.0
 *  Copyright CANON INC. 2004
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */



#ifndef	_PDLIPS_H
#define	_PDLIPS_H



#define	C_NULL		0x00
#define	C_EXT		0x03
#define	C_ACK		0x06
#define	C_BEL		0x07
#define	C_BS		0x08
#define	C_HT		0x09
#define	C_LF		0x0a
#define	C_VT		0x0b
#define	C_FF		0x0c
#define	C_CR		0x0d
#define	C_SO		0x0e
#define	C_SI		0x0f
#define	C_XON		0x11
#define	C_XOFF		0x13
#define	C_SS2		0x19
#define	C_ESC		0x1b
#define	C_SS3		0x1d
#define	C_IS2		0x1e
#define	C_SP		0x20
#define	C_DEL		0x7f


bool pdWrite(printerContextData *pcd, char *buf, int datasize);
bool pdWriteStr(printerContextData *pcd, char *buf);
void pdConvParam(char *str, int data);
void pdConvParamAdd(char *str, int data);
u_int pdConvColorValue(u_char color);
u_int pdConvGrayValue(u_char R, u_char G, u_char B);
int  packbitsCompress(u_char *dst, u_char *src, int count);

bool pdlips_PrtInit(printerContextData *pcd);
bool pdlips_PrtStart(printerContextData *pcd, pdFormParam *formdata);
bool pdlips_PrtEnd(printerContextData *pcd);
bool pdlips_Out_FF(printerContextData *pcd);
bool pdlips_Set_ROP(printerContextData *pcd);
bool pdlips_Set_Clip(printerContextData *pcd, int pid);
bool pdlips_Reset_Clip(printerContextData *pcd, int pid);
bool pdlips_Set_FillMode(printerContextData *pcd, pdFillMode fillmode);
bool pdlips_Set_AllAttr(printerContextData *pcd);



int	lipsStartJob(int printerContext, char *jobInfo);
int lipsEndJob(int printerContext);
int lipsAbortJob(int printerContext);
int lipsStartDoc(int printerContext, char *docInfo);
int	lipsEndDoc(int printerContext);
int	lipsStartPage(int printerContext, char *pageInfo);
int	lipsEndPage(int printerContext);

int	lipsResetCTM(int printerContext);
int	lipsSetCTM(int printerContext, pdCTM *pCTM);
int lipsGetCTM(int printerContext, pdCTM *pCTM);
int	lipsInitGS(int printerContext);
int	lipsSaveGS(int printerContext);
int	lipsRestoreGS(int printerContext);
int	lipsQueryColorSpace(int printerContext, pdColorSpace *pcspace, int *pnum);
int	lipsQueryColorSpace1(int printerContext, int *pnum, pdColorSpace *pcspace);
int	lipsSetColorSpace(int printerContext, pdColorSpace cspace);
int	lipsGetColorSpace(int printerContext, pdColorSpace *pcspace);
int	lipsQueryROP(int printerContext, int *pnum, int *prop);
int	lipsSetROP(int printerContext, int rop);
int lipsGetROP(int printerContext, int *prop);
int	lipsSetFillMode(int printerContext, pdFillMode fillmode);
int	lipsGetFillMode(int printerContext, pdFillMode *pfillmode);
int	lipsSetLineWidth(int printerContext, pdFix width);
int	lipsGetLineWidth(int printerContext, pdFix *pwidth);
int	lipsSetLineDash(int printerContext, pdFix pdash[], int num);
int	lipsSetLineDash1(int printerContext, int num, pdFix pdash[]);
int	lipsGetLineDash(int printerContext, pdFix pdash[], int *pnum);
int	lipsGetLineDash1(int printerContext, int *pnum, pdFix pdash[]);
int	lipsSetLineDashOffset(int printerContext, pdFix offset);
int	lipsGetLineDashOffset(int printerContext, pdFix *poffset);
int	lipsSetLineStyle(int printerContext, pdLineStyle linestyle);
int	lipsGetLineStyle(int printerContext, pdLineStyle *plinestyle);
int lipsSetLineCap(int printerContext, pdLineCap linecap);
int	lipsGetLineCap(int printerContext, pdLineCap *plinecap);
int	lipsSetLineJoin(int printerContext, pdLineJoin linejoin);
int	lipsGetLineJoin(int printerContext, pdLineJoin *plinejoin);
int	lipsSetMiterLimit(int printerContext, pdFix miterlimit);
int	lipsGetMiterLimit(int printerContext, pdFix *pmiterlimit);
int	lipsSetPaintMode(int printerContext, pdPaintMode paintmode);
int	lipsGetPaintMode(int printerContext, pdPaintMode *ppaintmode);
int lipsSetStrokeColor(int printerContext, pdBrush *brush);
int	lipsSetFillColor(int printerContext, pdBrush *brush);

int	lipsNewPath(int printerContext);
int	lipsEndPath(int printerContext);
int	lipsStrokePath(int printerContext);
int	lipsFillPath(int printerContext);
int	lipsStrokeFillPath(int printerContext);
int	lipsSetClipPath(int printerContext, pdClipRule clipRule);
int	lipsResetClipPath(int printerContext);
int	lipsSetCurrentPoint(int printerContext, pdFix x, pdFix y);
int	lipsLinePath(int printerContext, int flag, int npoints, pdPoint *points);
int	lipsPolygonPath(int printerContext, int npolygons, int *nvertexes, pdPoint *points);
int	lipsRectanglePath(int printerContext, int nrectangles, pdRectangle *rectangles);
int	lipsBezierPath(int printerContext, int npoints, pdPoint *points);

int lipsDrawBitmapText(int printerContext, int width, int height, int pitch, void *fontdata);

int lipsDrawImage(int printerContext, int sourceWidth, int sourceHeight, int colorSpace, pdImageFormat imageFormat,
					pdRectangle destinationSize, int count, void *imageData);
int lipsDrawImage1(int printerContext, int sourceWidth, int sourceHeight, int sourcePitch,
					pdImageFormat imageFormat,int destinationWidth, int destinationHeight, void *imageData);
int	lipsStartDrawImage(int printerContext, int sourceWidth, int sourceHeight, int colorDepth, pdImageFormat imageFormat, pdRectangle destinationSize);
int	lipsStartDrawImage1(int printerContext, int sourceWidth, int sourceHeight, int sourcePitch,
						pdImageFormat imageFormat, int destinationWidth, int destinationHeight);
int	lipsTransferDrawImage(int printerContext, int count, void *imageData);
int	lipsEndDrawImage(int printerContext);

#if 0
int lipsStartScanline(int printerContext, int yposition);
int	lipsScanline(int printerContext, int nscanpairs, int *scanpairs);
int	lipsEndScanline(int printerContext);

int	lipsStartRaster(int printerContext, int rasterWidth);
int	lipsTransferRasterData(int printerContext, int count, unsigned char *data);
int	lipsSkipRaster(int printeContext, int count);
int	lipsEndRaster(int printerContext);

int	lipsStartStream(int printerContext);
int	lipsTransferStreamData(int printerContext, int count, void *data);
int	lipsEndStream(int printerContext);
#endif

enum {
	API_OpenPrinter,
	API_ClosePrinter,

	API_StartJob,
	API_EndJob,
	API_StartDoc,
	API_EndDoc,
	API_StartPage,
	API_EndPage,
	API_QueryDeviceCapability,
	API_QueryDeviceInfo,

	API_ResetCTM,
	API_SetCTM,
	API_GetCTM,
	API_InitGS,
	API_SaveGS,
	API_RestoreGS,
	API_QueryColorSpace,
	API_SetColorSpace,
	API_GetColorSpace,
	API_QueryROP,
	API_SetROP,
	API_GetROP,
	API_SetFillMode,
	API_GetFillMode,
	API_SetAlphaConstant,
	API_GetAlphaConstant,
	API_SetLineWidth,
	API_GetLineWidth,
	API_SetLineDash,
	API_GetLineDash,
	API_SetLineDashOffset,
	API_GetLineDashOffset,
	API_SetLineStyle,
	API_GetLineStyle,
	API_SetLineCap,
	API_GetLineCap,
	API_SetLineJoin,
	API_GetLineJoin,
	API_SetMiterLimit,
	API_GetMiterLimit,
	API_SetPaintMode,
	API_GetPaintMode,
	API_SetStrokeColor,
	API_SetFillColor,
	API_SetBgColor,

	API_NewPath,
	API_EndPath,
	API_StrokePath,
	API_FillPath,
	API_StrokeFillPath,
	API_SetClipPath,
	API_ResetClipPath,
	API_SetCurrentPoint,
	API_LinePath,
	API_PolygonPath,
	API_RectanglePath,
	API_RoundRectanglePath,
	API_BezierPath,
	API_ArcPath,

	API_DrawBitmapText,

	API_DrawImage,
	API_StartDrawImage,
	API_TransferDrawImage,
	API_EndDrawImage,

	API_StartScanline,
	API_Scanline,
	API_EndScanline,

	API_StartRaster,
	API_TransferRasterData,
	API_SkipRaster,
	API_EndRaster,

	API_StartStream,
	API_TransferStreamData,
	API_EndStream,

	API_Count
};

#endif
