%define VERSION 5.90
%define RELEASE 1.00

%ifarch x86_64
%define	_machine_type "MACHINETYPE=x86_64"
%define	_cflags "CFLAGS=-m64 -march=x86-64"
%define LIBS  libs64/intel
%else
%ifarch aarch64
%define	_machine_type "MACHINETYPE=aarch64"
%define _cflags "CFLAGS=-fsigned-char"
%define	LIBS libs64/arm
%else
%ifarch mips64el
%define	_machine_type "MACHINETYPE=mips64el"
%define _cflags ""
%define	LIBS libs64/mips
%else
%define	_machine_type "MACHINETYPE=i686"
%define	_cflags "CFLAGS=-m32 -march=i686"
%define LIBS  libs32/intel
%endif
%endif
%endif
%define locallibs  /usr/lib

%define common_dir cnrdrvcups-common-%{VERSION}
%define driver_dir cnrdrvcups-lips4-%{VERSION}
%define utility_dir cnrdrvcups-utility-%{VERSION}
%define b_lib_dir %{_builddir}/lib
%define b_include_dir %{_builddir}/include

%define debug_package %{nil}

#==== introduction ============================================================================================
Summary: Canon LIPS4 Printer Driver for Linux v%{VERSION}
Name: cnrdrvcups-lips4
Version: %{VERSION}
Release: %{RELEASE}
License: See the LICENSE*.txt file.
# Copyright: Copyright CANON INC. 2004
Vendor: CANON INC.
Group: Applications/Publishing
Requires: cups, ghostscript, gtk3, libgcrypt, zlib, /usr/bin/lsb_release
Obsoletes: cnrcupsiradv45253lj, cnrcupsiradv45453lj, cnrcupsiradv65603lj, cnrcupsiradv65653lj, cnrcupsiradv65753lj, cnrcupsiradv85053lj, cnrcupsiradv85853lj, cnrcupsiradvc35203lj
Obsoletes: cnrcupsiradvc3563lj, cnrcupsiradvc55353lj, cnrcupsiradvc55503lj, cnrcupsiradvc75653lj, cnrcupsiradvc75803lj, cnrcupslbp852clj, cnrcupslbp853clj, cnrcupsiprc165lj
Obsoletes: cnrcupslbp322lj, cnrcupsiprc660lj, cnrcupsiradv4725lj, cnrcupsiradv4745lj, cnrcupsiradv6000lj, cnrcupsiradv6765lj, cnrcupsiradv6780lj, cnrcupsiradv8705lj
Obsoletes: cnrcupsiradv8786lj, cnrcupsiradvc357lj, cnrcupsiradvc3720lj, cnrcupsiradvc5735lj, cnrcupsiradvc5750lj, cnrcupsiradvc7765lj, cnrcupsiradvc7780lj, cnrcupsmf7525lj
Obsoletes: cnrcupsiprc170lj, cnrcupsiradv6860lj, cnrcupsiradvc3826lj, cnrcupsiradvc3830lj, cnrcupsiradvc3835lj, cnrcupsiradvc5840lj, cnrcupsiradvc5860lj, cnrcupsirc3222lj
Obsoletes: cnrcupslbp722clj, cnrcupslbp961clj, cnrcupsmf832clj
Source0: cnrdrvcups-lips4-%{version}-%{release}.tar.xz
BuildRoot: %{_tmppath}/%{name}-root

%description
Canon LIPS4 Printer Driver for Linux. 
This LIPS4 printer driver provides printing functions for Canon LBP/iR
printers operating under the CUPS (Common UNIX Printing System) environment.

#==== prep section ============================================================================================
%prep

%setup -q
if [ %{nobuild} != '1' ]; then
	##### common #####
	cd %{_builddir}/%{common_dir}
	cd buftool
	./autogen.sh %{_machine_type} %{_cflags} --prefix=%{_prefix} --libdir=%{_libdir} --enable-progpath=%{_bindir} --disable-shared --enable-static

	cd ../cngplp
	./autogen.sh %{_machine_type} %{_cflags} --prefix=%{_prefix} --libdir=%{locallibs} COMMON_SUFFIX=l

	cd ../backend
	./autogen.sh %{_machine_type} %{_cflags} --prefix=%{_prefix} --libdir=%{_libdir} MODULE_SUFFIX=lips
	cd ..

	##### driver #####
	cd ${RPM_BUILD_DIR}/%{driver_dir}
	cd driver
	./autogen.sh %{_machine_type} %{_cflags} --prefix=%{_prefix} --libdir=%{_libdir} --enable-shared --disable-static

	cd ../pstolipscpca
	./autogen.sh %{_machine_type} %{_cflags} --prefix=%{_prefix} --libdir=%{_libdir} --enable-progpath=%{_bindir}

	cd ../cpca
	./autogen.sh %{_machine_type} %{_cflags} --prefix=%{_prefix} --libdir=%{_libdir} --enable-progpath=%{_bindir}

	cd ../cngplp
	./autogen.sh %{_machine_type} %{_cflags} --prefix=%{_prefix} --libdir=%{_libdir}

	cd files
	./autogen.sh %{_machine_type} %{_cflags} 
	cd ..

	cd ..
fi

#==== build section ============================================================================================
%build
	if [ %{nobuild} != '1' ]; then
	cd ${RPM_BUILD_DIR}/%{common_dir}
	cd buftool
	make
	cp libbuftool.a %{b_lib_dir}/
	cp buftool.h %{b_include_dir}/
	cp buflist.h %{b_include_dir}/
	cd ..

	make 
fi

#==== install section ============================================================================================
%install

mkdir -pv ${RPM_BUILD_ROOT}%{_libdir}
mkdir -pv ${RPM_BUILD_ROOT}%{_bindir}
mkdir -pv ${RPM_BUILD_ROOT}%{_prefix}/bin
mkdir -pv ${RPM_BUILD_ROOT}%{locallibs}/cups/filter
mkdir -pv ${RPM_BUILD_ROOT}%{locallibs}/cups/backend/
mkdir -pv ${RPM_BUILD_ROOT}%{_prefix}/share/locale/ja/LC_MESSAGES
mkdir -pv ${RPM_BUILD_ROOT}%{_prefix}/share/cups/usb
mkdir -pv ${RPM_BUILD_ROOT}%{_prefix}/share/cups/model
# cngplp
mkdir -pv ${RPM_BUILD_ROOT}%{_prefix}/share/cngplpl/
mkdir -pv ${RPM_BUILD_ROOT}%{locallibs}
#utility
mkdir -pv ${RPM_BUILD_ROOT}%{_prefix}/share/cnsetuputill
mkdir -pv ${RPM_BUILD_ROOT}%{_prefix}/share/locale/ja/LC_MESSAGES
mkdir -pv ${RPM_BUILD_ROOT}%{_prefix}/share/locale/de/LC_MESSAGES
mkdir -pv ${RPM_BUILD_ROOT}%{_prefix}/share/locale/es/LC_MESSAGES
mkdir -pv ${RPM_BUILD_ROOT}%{_prefix}/share/locale/fr/LC_MESSAGES
mkdir -pv ${RPM_BUILD_ROOT}%{_prefix}/share/locale/it/LC_MESSAGES
mkdir -pv ${RPM_BUILD_ROOT}%{_prefix}/share/locale/zh_CN/LC_MESSAGES
mkdir -pv ${RPM_BUILD_ROOT}%{_prefix}/share/locale/ko/LC_MESSAGES
mkdir -pv ${RPM_BUILD_ROOT}%{_prefix}/share/locale/zh_TW/LC_MESSAGES

#### common ####
if [ %{nobuild} != '1' ]; then
	cd ${RPM_BUILD_DIR}/%{common_dir}
	make install DESTDIR=${RPM_BUILD_ROOT} COMMON_SUFFIX=l

	install -c -m 644 Rule/canon-laser-printer.usb-quirks	${RPM_BUILD_ROOT}%{_prefix}/share/cups/usb/canon-laser-printer_lips.usb-quirks
	cd -
else
	mkdir -pv -m 777 ${RPM_BUILD_ROOT}/etc/cngplpl/account
	mkdir -pv -m 777 ${RPM_BUILD_ROOT}/etc/cngplpl/options

	cd %{b_lib_dir}
	install -c -m 755 %{LIBS}/cnjatooll		${RPM_BUILD_ROOT}%{_bindir}
	install -c -m 755 %{LIBS}/cngplpl		${RPM_BUILD_ROOT}%{_bindir}
	install -c -m 755 %{LIBS}/cnusblips		${RPM_BUILD_ROOT}%{locallibs}/cups/backend
	cd -

	cd ${RPM_BUILD_DIR}/%{common_dir}
	install -c -m 644 Rule/canon-laser-printer.usb-quirks	${RPM_BUILD_ROOT}%{_prefix}/share/cups/usb/canon-laser-printer_lips.usb-quirks
	cd -
fi

#### driver ####
if [ %{nobuild} != '1' ]; then
	cd ${RPM_BUILD_DIR}/%{driver_dir}
	make install DESTDIR=${RPM_BUILD_ROOT}

	install -c -m 644 ppd/CNR*.ppd			${RPM_BUILD_ROOT}%{_prefix}/share/cups/model
	cd -
else
	cd ${RPM_BUILD_DIR}/%{common_dir}
	install -c -m 644 cngplp/src/cngplp.ui							    ${RPM_BUILD_ROOT}%{_prefix}/share/cngplpl
	cd -

	cd ${RPM_BUILD_DIR}/%{driver_dir}
	install -c -m 644 cngplp/files/cngplp_lips.ui						${RPM_BUILD_ROOT}%{_prefix}/share/cngplpl
	install -c -m 644 cngplp/files/func_config_lips.xml				    ${RPM_BUILD_ROOT}%{_prefix}/share/cngplpl
	install -c -m 644 cngplp/files/*.res								${RPM_BUILD_ROOT}%{_prefix}/share/cngplpl
	cd -

	cd %{b_lib_dir}
	install -c -m 755 %{LIBS}/libuictllipsr.so.1.0.0					${RPM_BUILD_ROOT}%{_libdir}
	install -c -m 755 %{LIBS}/libcanonlipsr.so.1.0.0					${RPM_BUILD_ROOT}%{_libdir}
	install -c -m 755 %{LIBS}/pstolipscpcar								${RPM_BUILD_ROOT}%{locallibs}/cups/filter
	install -c -m 644 %{LIBS}/ja/LC_MESSAGES/cngplpl.mo					${RPM_BUILD_ROOT}%{_prefix}/share/locale/ja/LC_MESSAGES
	install -c -m 644 %{LIBS}/de/LC_MESSAGES/cngplpl.mo					${RPM_BUILD_ROOT}%{_prefix}/share/locale/de/LC_MESSAGES
	install -c -m 644 %{LIBS}/es/LC_MESSAGES/cngplpl.mo					${RPM_BUILD_ROOT}%{_prefix}/share/locale/es/LC_MESSAGES
	install -c -m 644 %{LIBS}/fr/LC_MESSAGES/cngplpl.mo					${RPM_BUILD_ROOT}%{_prefix}/share/locale/fr/LC_MESSAGES
	install -c -m 644 %{LIBS}/it/LC_MESSAGES/cngplpl.mo					${RPM_BUILD_ROOT}%{_prefix}/share/locale/it/LC_MESSAGES
	install -c -m 644 %{LIBS}/zh_CN/LC_MESSAGES/cngplpl.mo				${RPM_BUILD_ROOT}%{_prefix}/share/locale/zh_CN/LC_MESSAGES
	install -c -m 644 %{LIBS}/ko/LC_MESSAGES/cngplpl.mo					${RPM_BUILD_ROOT}%{_prefix}/share/locale/ko/LC_MESSAGES
	install -c -m 644 %{LIBS}/zh_TW/LC_MESSAGES/cngplpl.mo				${RPM_BUILD_ROOT}%{_prefix}/share/locale/zh_TW/LC_MESSAGES
	install -c -m 644 %{LIBS}/ja/LC_MESSAGES/libuictllipsr.1.0.mo		${RPM_BUILD_ROOT}%{_prefix}/share/locale/ja/LC_MESSAGES
	install -c -m 644 %{LIBS}/de/LC_MESSAGES/libuictllipsr.1.0.mo		${RPM_BUILD_ROOT}%{_prefix}/share/locale/de/LC_MESSAGES
	install -c -m 644 %{LIBS}/es/LC_MESSAGES/libuictllipsr.1.0.mo		${RPM_BUILD_ROOT}%{_prefix}/share/locale/es/LC_MESSAGES
	install -c -m 644 %{LIBS}/fr/LC_MESSAGES/libuictllipsr.1.0.mo		${RPM_BUILD_ROOT}%{_prefix}/share/locale/fr/LC_MESSAGES
	install -c -m 644 %{LIBS}/it/LC_MESSAGES/libuictllipsr.1.0.mo		${RPM_BUILD_ROOT}%{_prefix}/share/locale/it/LC_MESSAGES
	install -c -m 644 %{LIBS}/zh_CN/LC_MESSAGES/libuictllipsr.1.0.mo	${RPM_BUILD_ROOT}%{_prefix}/share/locale/zh_CN/LC_MESSAGES
	install -c -m 644 %{LIBS}/ko/LC_MESSAGES/libuictllipsr.1.0.mo		${RPM_BUILD_ROOT}%{_prefix}/share/locale/ko/LC_MESSAGES
	install -c -m 644 %{LIBS}/zh_TW/LC_MESSAGES/libuictllipsr.1.0.mo	${RPM_BUILD_ROOT}%{_prefix}/share/locale/zh_TW/LC_MESSAGES
	cd -

	cd ${RPM_BUILD_DIR}/%{driver_dir}
	install -c -m 644 ppd/CNR*.ppd			${RPM_BUILD_ROOT}%{_prefix}/share/cups/model
	cd -
fi

cd ${RPM_BUILD_ROOT}%{_libdir}
ln -sf libuictllipsr.so.1.0.0 libuictllipsr.so
ln -sf libuictllipsr.so.1.0.0 libuictllipsr.so.1
ln -sf libcanonlipsr.so.1.0.0 libcanonlipsr.so
ln -sf libcanonlipsr.so.1.0.0 libcanonlipsr.so.1
cd -

cd %{b_lib_dir}
install -c -m 4755 %{LIBS}/cnpkmodulelipsr 	${RPM_BUILD_ROOT}%{_bindir}
cd -

#### utility ####
cd ${RPM_BUILD_DIR}/%{utility_dir}
install -c -m 644 data/cnsetuputil.ui	${RPM_BUILD_ROOT}%{_prefix}/share/cnsetuputill
cd %{b_lib_dir}
install -c -m 755 %{LIBS}/cnsetuputill	${RPM_BUILD_ROOT}%{_prefix}/bin
install -c -m 644 %{LIBS}/ja/LC_MESSAGES/cnsetuputill.mo       ${RPM_BUILD_ROOT}%{_prefix}/share/locale/ja/LC_MESSAGES
install -c -m 644 %{LIBS}/de/LC_MESSAGES/cnsetuputill.mo       ${RPM_BUILD_ROOT}%{_prefix}/share/locale/de/LC_MESSAGES
install -c -m 644 %{LIBS}/es/LC_MESSAGES/cnsetuputill.mo       ${RPM_BUILD_ROOT}%{_prefix}/share/locale/es/LC_MESSAGES
install -c -m 644 %{LIBS}/fr/LC_MESSAGES/cnsetuputill.mo       ${RPM_BUILD_ROOT}%{_prefix}/share/locale/fr/LC_MESSAGES
install -c -m 644 %{LIBS}/it/LC_MESSAGES/cnsetuputill.mo       ${RPM_BUILD_ROOT}%{_prefix}/share/locale/it/LC_MESSAGES
install -c -m 644 %{LIBS}/zh_CN/LC_MESSAGES/cnsetuputill.mo    ${RPM_BUILD_ROOT}%{_prefix}/share/locale/zh_CN/LC_MESSAGES
install -c -m 644 %{LIBS}/ko/LC_MESSAGES/cnsetuputill.mo       ${RPM_BUILD_ROOT}%{_prefix}/share/locale/ko/LC_MESSAGES
install -c -m 644 %{LIBS}/zh_TW/LC_MESSAGES/cnsetuputill.mo    ${RPM_BUILD_ROOT}%{_prefix}/share/locale/zh_TW/LC_MESSAGES
cd -


#==== clean section ============================================================================================
%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ -x /sbin/ldconfig ]; then
	/sbin/ldconfig
fi
if [ -f /etc/init.d/cups ]
then
	/etc/init.d/cups restart
elif [ -f /etc/init.d/cupsys ]
then
	/etc/init.d/cupsys restart
else
	service cups restart
fi
if [ -z "$LANG" ]
then
	export LANG=`localectl | grep -Eo "LANG=.*" | awk -F '=' '{print $2}'`
fi
export DISPLAY=:0
user=`users | awk '{print $1}'`
runuser -u $user xhost +SI:localuser:root
cnsetuputill

%postun
if [ -x /sbin/ldconfig ]; then
	/sbin/ldconfig
fi

#==== files section ============================================================================================
%files
%defattr(-,root,root)

%{_prefix}/share/locale/ja/LC_MESSAGES/cngplpl.mo
%{_prefix}/share/locale/de/LC_MESSAGES/cngplpl.mo
%{_prefix}/share/locale/es/LC_MESSAGES/cngplpl.mo
%{_prefix}/share/locale/fr/LC_MESSAGES/cngplpl.mo
%{_prefix}/share/locale/it/LC_MESSAGES/cngplpl.mo
%{_prefix}/share/locale/zh_CN/LC_MESSAGES/cngplpl.mo
%{_prefix}/share/locale/ko/LC_MESSAGES/cngplpl.mo
%{_prefix}/share/locale/zh_TW/LC_MESSAGES/cngplpl.mo
# cngplp
%{_prefix}/share/cngplpl/cngplp.ui
#
%{_prefix}/bin/cngplpl
%{_prefix}/bin/cnjatooll
%{locallibs}/cups/backend/cnusblips
%{_sysconfdir}/cngplpl/account
%{_sysconfdir}/cngplpl/options

%{_prefix}/share/cups/usb/canon-laser-printer_lips.usb-quirks

%{_bindir}/cnpkmodulelipsr
%{_libdir}/libcanonlipsr.*
%{locallibs}/cups/filter/pstolipscpcar
%{_prefix}/share/cups/model/CNRCUPS*LJ.ppd
# cngplp
%{_libdir}/libuictllipsr.*
%{_prefix}/share/cngplpl/cngplp_lips.ui
%{_prefix}/share/cngplpl/*.res
%{_prefix}/share/cngplpl/func_config_lips.xml
%{_prefix}/share/locale/ja/LC_MESSAGES/libuictllipsr*.mo
%{_prefix}/share/locale/fr/LC_MESSAGES/libuictllipsr*.mo
%{_prefix}/share/locale/it/LC_MESSAGES/libuictllipsr*.mo
%{_prefix}/share/locale/de/LC_MESSAGES/libuictllipsr*.mo
%{_prefix}/share/locale/es/LC_MESSAGES/libuictllipsr*.mo
%{_prefix}/share/locale/zh_CN/LC_MESSAGES/libuictllipsr*.mo
%{_prefix}/share/locale/ko/LC_MESSAGES/libuictllipsr*.mo
%{_prefix}/share/locale/zh_TW/LC_MESSAGES/libuictllipsr*.mo

%{_prefix}/share/cnsetuputill/cnsetuputil.ui
%{_prefix}/share/locale/ja/LC_MESSAGES/cnsetuputill.mo
%{_prefix}/share/locale/de/LC_MESSAGES/cnsetuputill.mo
%{_prefix}/share/locale/es/LC_MESSAGES/cnsetuputill.mo
%{_prefix}/share/locale/fr/LC_MESSAGES/cnsetuputill.mo
%{_prefix}/share/locale/it/LC_MESSAGES/cnsetuputill.mo
%{_prefix}/share/locale/zh_CN/LC_MESSAGES/cnsetuputill.mo
%{_prefix}/share/locale/ko/LC_MESSAGES/cnsetuputill.mo
%{_prefix}/share/locale/zh_TW/LC_MESSAGES/cnsetuputill.mo
%{_prefix}/bin/cnsetuputill
